<?php
//ini_set('display_startup_errors', 1);
//ini_set('display_errors', 1);
//error_reporting(-1);
error_reporting(E_ALL ^ E_NOTICE);
// Checks to see if a delimited data file is changing or not (flatlined)
// Requires that a text file named flatline-status.txt be on the server with write permissions (CHMOD 666)
// Include this in a page where you want the message to show up if the data is flatlined
// If flatlined an EMail can be sent
// 
// 5-9-12 - Updated to PHP 5 timezone function
// 3-8-19 - Fixed some date() issues & removed the mail test variable
// Jim McMurry - jcweather.us - jmcmurry@mwt.net
//
// Configuration
date_default_timezone_set("Europe/Madrid");       // Zones available at http://us2.php.net/manual/en/timezones.php
header("Content-Type: text/html;charset=utf-8");
$ahora = date('H:i:s');
$cachefile = '/var/www/html/script/alertarealtime.txt';          // File to hold cached data for comparison
$watchfile = '/var/www/html/realtime.txt';                       // Data file to watch for changes
$logFile = fopen("/var/www/html/script/log/errorscript.txt", 'a') or die("Error creando archivo");
$infofile = '/var/www/html/script/mensaje.txt';
$nota = 'Por problemas de comunicacion la web no puede ser actualizada. En breve esperamos solucionarlo.';
$nota2 = '';
$delimit   = " ";                                   // Delimeter used in that file
$offset1   = 1;                                     // Hora
$offset2   = 2;                                     // Temperatura exterior
$offset3   = 4;                                     // Rocio
$offset4   = 5;                                     // Cojinete del viento
$offset5   = 11;                                    // Direccion actual del viento (punto de la brujula)
$maxage    = 10;                                    // Minutes that the data can remain unchanged w/o email. Recommend minimum 30
$to   	   = 'correo@gmail.com';                    // EMail info
$from      = 'ALERTA-suweb.es';
$subject   = ("Realtime esta offline. "). $ahora;
$subject2  = ("Realtime esta online. "). $ahora;
$body      = '. Ultima actualizacion a las ';  // Will go between current date/time & last good date/time in the EMail Body.
//$HTMLMsg   = '<div style="text-align:center;">ALERTA, los datos meteorologicos no estan actualizados.</div>';
// End of configurable items
$now = time();

$newdata = get_contents( $watchfile , $delimit);        // read the target file
$current = " (" . @$newdata[$offset1] . " " . @$newdata[$offset2] . " " . @$newdata[$offset3] . " " . @$newdata[$offset4] . " " . @$newdata[$offset5] . ")";
$cachedata = get_contents( $cachefile , ",");           // read the cache file
$cachetime = $cachedata[0];
if (@$newdata[0] != -9999 && $cachedata[0] != -9999) {   // was able to read the files
	$flat = (@$newdata[$offset1] == $cachedata[1]) &&
			(@$newdata[$offset2] == $cachedata[2]) &&
			(@$newdata[$offset3] == $cachedata[3]) &&
			(@$newdata[$offset4] == $cachedata[4]) &&
			(@$newdata[$offset5] == $cachedata[5]);      // compare various offsets
	$status = substr(trim($cachedata[6]), 0, 4);        // capture the "sent" if it's already there
	$WatchSpan = round(($now - $cachetime) / 60);       // minutes since last data change
	if ($flat) {
		if ($WatchSpan >= $maxage) {                    // wait time is expired	
			if ( $status != "sent" ) {                  // mail hasn't been sent yet
            	file_put_contents($infofile, $nota);  
				mail($to, $subject , date("d-m-y H:i:s") . $body . date( "d-m-y H:i:s", $cachetime) . $current, 'From: ' . $from);
		       	file_get_contents(' https://api.telegram.org/bot{BOT_API_TOKEN}/sendMessage?chat_id={CHANNEL_ID}&subject');
				$status ="sent "  . date("d-m-y H:i:s", $now);
            } else {
				$status = trim($cachedata[6]);         // carry over the original entry
			}
			 $HTMLMsg;                                       // put the message on the screen
		} else {
			$status="Escuchando desde: " . date("H:i:s", $cachetime) . ", ahora a las " . date("H:i:s", $now) . ", sin cambios desde hace " . $WatchSpan . " min";
		}
		$now = $cachetime;                                     // leave timestamp as it was for now
	} else {
		if ( $status == "sent" ) {           // mail previously sent				
		file_put_contents($infofile, $nota2);  
        mail($to, $subject2 ,"Vuelve a estar activo a las " . date("d-m-y H:i:s") . $current, 'From: ' . $from);
			file_get_contents(' https://api.telegram.org/bot{BOT_API_TOKEN}/sendMessage?chat_id={CHANNEL_ID}&subject2');
}
		$status="active " . date("d-m-y H:i:s", $now);
	}
	$fp = fopen($cachefile, "w") or die("SUGERENCIA: Sube un fichero llamado " . $cachefile . " y dale permisos de (CHMOD 666).");
	fputs($fp, $now . "," . @$newdata[$offset1] . "," . @$newdata[$offset2] . "," . @$newdata[$offset3] . "," . @$newdata[$offset4] . "," . @$newdata[$offset5] . ", " . $status);
	fclose($fp);
}   // else we couldn't read one of the files

function get_contents( $rawfile , $delimiter) {
    $rawdata = array();
    $fd = fopen($rawfile, "r");
    if ($fd) {
        $rawinfo = '';
        while (! feof ($fd) ) {
            $rawinfo .= fread($fd, 8192);
        }
        fclose($fd);
		$rawinfo = preg_replace("/\x0D/", "", $rawinfo);
		$rawinfo = preg_replace("/\x0A/", "", $rawinfo);
        $rawdata = explode ($delimiter, $rawinfo);
    } else {
        $rawdata[0]= -9999;
    }
    return $rawdata;
}
if (isset($newdata[$offset1],$newdata[$offset2],$newdata[$offset3],$newdata[$offset4],$newdata[$offset5])){
 // echo "La variables están definidas.";
} else {
	/*
echo "\n";
echo "La variables no están definidas.  \n";
echo $now.' '.@$newdata[$offset1].' '.@$newdata[$offset2].' '.@$newdata[$offset3].' '.@$newdata[$offset4].' '.@$newdata[$offset5].' '.@$status; echo "\n";
*/
fwrite($logFile, "\n".date("d/m/Y H:i:s")." Alertarealtime: $newdata[$offset1] $newdata[$offset2] $newdata[$offset3] $newdata[$offset4] $newdata[$offset5]") or die("Error escribiendo en el archivo");fclose($logFile);
//exit;
}
?>